#ifndef rapidStream_h
#define rapidStream_h

#include <stdint.h>

//Buffer of past values


//Standard Deviation over Window

//Min accel over window
//Max accel over window

//Buffer of past satisfying condition
//expression

class rapidStream {
public:
    rapidStream();
    rapidStream(int windowSize);
    ~rapidStream();
    
    void clear();
    void pushToWindow(double input);
    
    double velocity();
    double acceleration();
    
    double minimum();
    double maximum();
    
    double sum();
    double mean();
    double standardDeviation();
    
    double minVelocity();
    double maxVelocity();
    
    double minAcceleration();
    double maxAcceleration();

private:
    uint32_t windowSize;
    uint32_t windowIndex;
    double *circularWindow;
    
    double calcCurrentVel(int i);
};


#endif